\renewcommand{\FIGREP}{src/spack/figures}

\section{Spack}
\label{sec:spack}
\intersec{jed}

\subsection{Packaging managers}
\label{sec:comp-with-spack}

\begin{frame}
  \frametitle{Packaging managers}
    \framesubtitle{}
    \begin{itemize}
      \item Software have multiple dependencies, installing all of them can be complicated
      \item Different types of packages managers
            \begin{itemize}
              \item OS: apt, yum, apple store, \emph{etc.}
              \item Language: pip, cargo, npm, \emph{etc.}
              \item Generic: brew, spack, nix, vcpkg, \emph{etc.}
            \end{itemize}
    \end{itemize}
\end{frame}

\begin{frame}
  \frametitle{Dependencies}
    \framesubtitle{}
    \addimage[width=9cm]{\FIGREP/py-torch}{3cm}{.5cm}
\end{frame}

\begin{frame}
  \frametitle{Spack}
    \framesubtitle{}
    \begin{itemize}
      \item Package manager designed for HPC
      \item Allow to have multiple versions of each software
      \item Compile everything from source, to optimize for the architecture
      \item Strong definition of the dependencies
      \item Used to install all the module on SCITAS clusters
      \item To use it just clone it \cmd{git clone https://github.com/spack/spack}
    \end{itemize}
\end{frame}

\begin{frame}[fragile]
  \frametitle{Spack dependencies}
  \framesubtitle{}
  \begin{bashcode}
    $ spack/bin/spack spec -Ilt emacs
  \end{bashcode}
  \vspace*{4cm}
  \addimage[width=14cm]{\FIGREP/spec}{1.5cm}{1cm}
\end{frame}

\begin{frame}[fragile]
  \frametitle{Spack basics}
  \framesubtitle{}
  \begin{itemize}
    \item On SCITAS cluster spack is preconfigurd
    \item Uses \cmd{upstream} configuration
    \item Compilers are defined \cmd{spack compiler list}
    \item Basic usage
          \begin{itemize}
            \item Find a package: \cmd{spack list <package>}
            \item Description of a package: \cmd{spack info <package>}
            \item Install: \cmd{spack install <spec>}
            \item Load a installed package: \cmd{spack load <spec|hash>}
          \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]
  \frametitle{Spack environment}
  \framesubtitle{}
  \begin{itemize}
    \item A more advanced way is to use environments
          \begin{itemize}
            \item Creating an environment: \cmd{spack env create <name>}
            \item Activating an environment: \cmd{spack env activate <name>}
          \end{itemize}
    \item It is a bit a pyenv
          \begin{itemize}
            \item Add packages: \cmd{spack add <spec>}
            \item Concretize everything new in the environment: \cmd{spack concretize}
            \item Concretized environment are written in a lock file
            \item Install everything: \cmd{spack install}
            \item Environments can be projected in a view: \cmd{spack view}
          \end{itemize}
    \item The lock and the view makes is look like a pyenv
    \item Can be compiled and installed in containers \cmd{spack containerize}
  \end{itemize}
\end{frame}


%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../../SCM_slides"
%%% TeX-command-extra-options: "-shell-escape"
%%% End:
